# -*- coding: utf-8 -*-
"""Lab 4 - EDA.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1yMdfddHfYebLQ_92kHWBYomUDg8FkOSe

#  Lab 4 - Cleaning and EDA of IMDB

# Table of Contents 
<ol start="0">
<li> Learning Objectives </li>
<li> Loading and Cleaning with Pandas</li>
<li> Asking Questions?  </li>
<li> Parsing and Completing the Dataframe  </li>
<li> EDA  </li>
<li> Determining the Best Movies </li>
<li>Trends in Popularity of Genres </li>
</ol>

## Learning Objectives

About 10000 "best movies" were fetched and parsed from IMDB. 

`imdb_top_10000.txt` contain data tabular format as a CSV file. In this lab we'll clean and further parse the data. We'll then do some exploratory data analysis to answer questions about these best books and popular genres.

By the end of this lab, you should be able to:

1. Load and systematically address missing values, ancoded as NaN values in our data set, for example, by removing observations associated with these values.

2. Parse columns in the dataframe to create new dataframe columns.
3. Create and interpret visualizations to explore the data set

### Basic EDA workflow


The basic workflow is as follows:

1. **Scrape**  data using beautiful soup and python request.
2. **Build** a DataFrame from the data (ideally, put all data in this object)
3. **Clean** the DataFrame. It should have the following properties:
    - Each row describes a single object
    - Each column describes a property of that object
    - Columns are numeric whenever appropriate
    - Columns contain atomic properties that cannot be further decomposed
4. Explore **global properties**. Use histograms, scatter plots, and aggregation functions to summarize the data.
5. Explore **group properties**. Use groupby and small multiples to compare subsets of the data.

This process transforms your data into a format which is easier to work with, gives you a basic overview of the data's properties, and likely generates several questions for you to followup in subsequent analysis.

## 1. Loading and Cleaning with Pandas
Read in the `imdb_top_10000.txt` file, examine the data, and do any necessary data cleaning.
The textfile is tab-separated, and doesn't have any column headers. We set the appropriate keywords in `pd.read_csv` to handle this

Here is a description of the columns (in order) present in this csv file:

```
imdbID: identifier for the IMDB
title: title of the movie
year: the year the movie was released.
score: Rating of the movie in the scale of 1 - 10
votes: Number of votes received for the movie
runtime: Duration of the movie in min
genres: Genre of the movie seperated by '|'
```
"""

import pandas as pd
import matplotlib as plt
import matplotlib.pyplot as plt

df = pd.read_csv("imdb_top_10000.txt",sep="\t",names=['imdbID','title','year','score','votes','runtime','genres'])

df.head()

df.dtypes

df.isna().sum()

df[df.genres.isna()]

df.shape

df.dropna(subset=["genres"],inplace=True)
df.shape

df.isna().sum()

"""## 2. Asking Questions

Find the longest and shortest runtime?
"""





"""## 3. Parsing and Completing the DataFrame

There are several problems with the DataFrame at this point:

- The runtime column describes a number, but is stored as a string
- The genres column is not atomic -- it aggregates several genres together. This makes it hard, for example, to extract which movies are Comedies.
- The movie year is repeated in the title and year column
"""

df.dtypes

run_time = [int(r.split(' ')[0]) for r in df.runtime]
df['runtime'] = run_time
df.head()

df.dtypes

genres = set()
for m in df.genres:
    genres.update(g for g in m.split('|'))
genres = sorted(genres)

#make a column for each genre
for genre in genres:
    df[genre] = [genre in movie.split('|') for movie in df.genres]
         
df.head()

"""separate year from movies"""

df['title'] = [t[0:-7] for t in df.title]
df.head()

"""## 4. EDA"""

new_df = df[['title', 'runtime']]
run_time = new_df['runtime']
print("Longest runtime")
print(run_time.max())
print("Shortest runtime")
print(run_time.min())

new_df = df[['title', 'runtime']]
result = new_df[(new_df['runtime'] >= 100)]
result.head()

"""## 5. Determining Best Movies"""

df[df.score == df.score.max()][['title', 'year', 'score', 'votes', 'genres', 'runtime']]



"""## 6. Trends in Popularity of Genres"""

#Get the unique genres contained in the dataframe.
genre_set = set()
for genre in df.genres:
    list_genre = genre.split("|")
    genre_set.update(list_genre)
    
len(genre_set)

genredf = df[list(genre_set)]
genredf.head()

#sorting to see the highest
genre_result= genredf.sum()
y = genre_result.sort_values(ascending=False)[:10]
x = y.index

plt.bar(x,y)
plt.xticks(rotation=90)
plt.show()